/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { BusinessObjectData } from '../model/businessObjectData';
import { BusinessObjectDataAttributesUpdateRequest } from '../model/businessObjectDataAttributesUpdateRequest';
import { BusinessObjectDataAvailability } from '../model/businessObjectDataAvailability';
import { BusinessObjectDataAvailabilityCollectionRequest } from '../model/businessObjectDataAvailabilityCollectionRequest';
import { BusinessObjectDataAvailabilityCollectionResponse } from '../model/businessObjectDataAvailabilityCollectionResponse';
import { BusinessObjectDataAvailabilityRequest } from '../model/businessObjectDataAvailabilityRequest';
import { BusinessObjectDataCreateRequest } from '../model/businessObjectDataCreateRequest';
import { BusinessObjectDataDdl } from '../model/businessObjectDataDdl';
import { BusinessObjectDataDdlCollectionRequest } from '../model/businessObjectDataDdlCollectionRequest';
import { BusinessObjectDataDdlCollectionResponse } from '../model/businessObjectDataDdlCollectionResponse';
import { BusinessObjectDataDdlRequest } from '../model/businessObjectDataDdlRequest';
import { BusinessObjectDataInvalidateUnregisteredRequest } from '../model/businessObjectDataInvalidateUnregisteredRequest';
import { BusinessObjectDataInvalidateUnregisteredResponse } from '../model/businessObjectDataInvalidateUnregisteredResponse';
import { BusinessObjectDataKeys } from '../model/businessObjectDataKeys';
import { BusinessObjectDataLegalHoldUpdateRequest } from '../model/businessObjectDataLegalHoldUpdateRequest';
import { BusinessObjectDataParentsUpdateRequest } from '../model/businessObjectDataParentsUpdateRequest';
import { BusinessObjectDataPartitions } from '../model/businessObjectDataPartitions';
import { BusinessObjectDataPartitionsRequest } from '../model/businessObjectDataPartitionsRequest';
import { BusinessObjectDataRetentionInformationUpdateRequest } from '../model/businessObjectDataRetentionInformationUpdateRequest';
import { BusinessObjectDataRetryStoragePolicyTransitionRequest } from '../model/businessObjectDataRetryStoragePolicyTransitionRequest';
import { BusinessObjectDataSearchRequest } from '../model/businessObjectDataSearchRequest';
import { BusinessObjectDataSearchResult } from '../model/businessObjectDataSearchResult';
import { BusinessObjectDataVersions } from '../model/businessObjectDataVersions';
import { S3KeyPrefixInformation } from '../model/s3KeyPrefixInformation';
import { Configuration } from '../configuration';
export declare class BusinessObjectDataService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * checkBusinessObjectDataAvailability
     * Performs a search and returns a list of business object data key values and relative statuses for a range of requested business object data.
     * @param businessObjectDataAvailabilityRequest the business object data availability request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataCheckBusinessObjectDataAvailability(businessObjectDataAvailabilityRequest: BusinessObjectDataAvailabilityRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataAvailability>;
    businessObjectDataCheckBusinessObjectDataAvailability(businessObjectDataAvailabilityRequest: BusinessObjectDataAvailabilityRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataAvailability>>;
    businessObjectDataCheckBusinessObjectDataAvailability(businessObjectDataAvailabilityRequest: BusinessObjectDataAvailabilityRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataAvailability>>;
    /**
     * checkBusinessObjectDataAvailabilityCollection
     * Performs an availability check for a collection of business object data. &lt;p&gt; Requires READ permission on ALL namespaces &lt;/p&gt;
     * @param businessObjectDataAvailabilityCollectionRequest the business object data availability collection request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataCheckBusinessObjectDataAvailabilityCollection(businessObjectDataAvailabilityCollectionRequest: BusinessObjectDataAvailabilityCollectionRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataAvailabilityCollectionResponse>;
    businessObjectDataCheckBusinessObjectDataAvailabilityCollection(businessObjectDataAvailabilityCollectionRequest: BusinessObjectDataAvailabilityCollectionRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataAvailabilityCollectionResponse>>;
    businessObjectDataCheckBusinessObjectDataAvailabilityCollection(businessObjectDataAvailabilityCollectionRequest: BusinessObjectDataAvailabilityCollectionRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataAvailabilityCollectionResponse>>;
    /**
     * createBusinessObjectData
     * Creates (i.e. registers) business object data. You may pre-register business object data by setting the status to one of the pre-registration statuses (UPLOADING, PENDING_VALID, and PROCESSING). &lt;p&gt; Requires WRITE permission on namespace &lt;/p&gt;
     * @param businessObjectDataCreateRequest the information needed to create the business object data
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataCreateBusinessObjectData(businessObjectDataCreateRequest: BusinessObjectDataCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataCreateBusinessObjectData(businessObjectDataCreateRequest: BusinessObjectDataCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataCreateBusinessObjectData(businessObjectDataCreateRequest: BusinessObjectDataCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * deleteBusinessObjectData
     * Deletes an existing business object data without subpartition values with namespace. &lt;p&gt; Requires WRITE permission on namespace &lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the partition value
     * @param businessObjectDataVersion the business object data version
     * @param deleteFiles whether files should be deleted
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataDeleteBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataDeleteBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataDeleteBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * deleteBusinessObjectData
     * Deletes an existing business object data with 1 subpartition value with namespace. &lt;p&gt; Requires WRITE permission on namespace &lt;/p&gt;
     * @param namespace the namespace.
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the partition value
     * @param subPartition1Value sub-partition value 1
     * @param businessObjectDataVersion the business object data version
     * @param deleteFiles whether files should be deleted
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataDeleteBusinessObjectData1(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataDeleteBusinessObjectData1(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataDeleteBusinessObjectData1(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * deleteBusinessObjectData
     * Deletes an existing business object data with 2 subpartition values with namespace. &lt;p&gt; Requires WRITE permission on namespace &lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the partition value
     * @param subPartition1Value sub-partition value 1
     * @param subPartition2Value sub-partition value 2
     * @param businessObjectDataVersion the business object data version
     * @param deleteFiles whether files should be deleted
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataDeleteBusinessObjectData2(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataDeleteBusinessObjectData2(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataDeleteBusinessObjectData2(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * deleteBusinessObjectData
     * Deletes an existing business object data with 3 subpartition values with namespace &lt;p&gt; Requires WRITE permission on namespace &lt;/p&gt;
     * @param namespace the namespace.
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the partition value
     * @param subPartition1Value sub-partition value 1
     * @param subPartition2Value sub-partition value 2
     * @param subPartition3Value sub-partition value 3
     * @param businessObjectDataVersion the business object data version
     * @param deleteFiles whether files should be deleted
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataDeleteBusinessObjectData3(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataDeleteBusinessObjectData3(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataDeleteBusinessObjectData3(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * deleteBusinessObjectData
     * Deletes an existing business object data with 4 subpartition values with namespace. &lt;p&gt; Requires WRITE permission on namespace &lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the partition value
     * @param subPartition1Value sub-partition value 1
     * @param subPartition2Value sub-partition value 2
     * @param subPartition3Value sub-partition value 3
     * @param subPartition4Value sub-partition value 4
     * @param businessObjectDataVersion the business object data version
     * @param deleteFiles whether files should be deleted
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataDeleteBusinessObjectData4(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, subPartition4Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataDeleteBusinessObjectData4(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, subPartition4Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataDeleteBusinessObjectData4(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, subPartition4Value: string, businessObjectDataVersion: number, deleteFiles?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * destroyBusinessObjectData
     * Initiates destruction process for an existing business object data. This endpoint uses S3 tagging to mark the relative S3 files for deletion. The S3 data then gets deleted by S3 bucket lifecycle policy that deletes data based on S3 tagging. This endpoint to be used to delete records that are selected and approved for destruction as per retention information specified for the relative business object format. &lt;p&gt; Requires WRITE permission on namespace &lt;/p&gt;
     * @param namespace the namespace of the business object definition
     * @param businessObjectDefinitionName the name of the business object definition
     * @param businessObjectFormatUsage the usage of the business object format
     * @param businessObjectFormatFileType the file type of the business object format
     * @param businessObjectFormatVersion the version of the business object format
     * @param partitionValue the primary partition value
     * @param businessObjectDataVersion the version of the business object data
     * @param subPartitionValues the list of sub-partition values delimited by \&quot;|\&quot; (delimiter can be escaped by \&quot;\\\&quot;)
     * @param batchMode the flag used to indicate that related S3 operations should be processed in S3 Batch mode
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataDestroyBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, subPartitionValues?: string, batchMode?: boolean, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataDestroyBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, subPartitionValues?: string, batchMode?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataDestroyBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, subPartitionValues?: string, batchMode?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * destroyNonRecordBusinessObjectData
     * Initiates destruction process for an existing business object data that is registered under business object format that is designated as \&quot;non-record\&quot; (recordFlag is explicitly set to \&quot;false\&quot;).  This endpoint uses S3 tagging to mark the relative S3 files for deletion. The S3 data then gets deleted by S3 bucket lifecycle policy that deletes data based on S3 tagging.
     * @param namespace the namespace of the business object definition
     * @param businessObjectDefinitionName the name of the business object definition
     * @param businessObjectFormatUsage the usage of the business object format
     * @param businessObjectFormatFileType the file type of the business object format
     * @param businessObjectFormatVersion the version of the business object format
     * @param partitionValue the primary partition value
     * @param businessObjectDataVersion the version of the business object data
     * @param subPartitionValues the list of sub-partition values delimited by \&quot;|\&quot; (delimiter can be escaped by \&quot;\\\&quot;)
     * @param batchMode the flag used to indicate that related S3 operations should be processed in S3 Batch mode
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataDestroyNonRecordBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, subPartitionValues?: string, batchMode?: boolean, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataDestroyNonRecordBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, subPartitionValues?: string, batchMode?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataDestroyNonRecordBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, subPartitionValues?: string, batchMode?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * generateBusinessObjectDataDdl
     * Retrieves the DDL to initialize the specified type of the database system to perform queries for a range of requested business object data in the specified storage. &lt;p&gt; Requires READ permission on namespace &lt;/p&gt;
     * @param businessObjectDataDdlRequest the business object data DDL request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataGenerateBusinessObjectDataDdl(businessObjectDataDdlRequest: BusinessObjectDataDdlRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataDdl>;
    businessObjectDataGenerateBusinessObjectDataDdl(businessObjectDataDdlRequest: BusinessObjectDataDdlRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataDdl>>;
    businessObjectDataGenerateBusinessObjectDataDdl(businessObjectDataDdlRequest: BusinessObjectDataDdlRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataDdl>>;
    /**
     * generateBusinessObjectDataDdlCollection
     * Retrieves the DDL to initialize the specified type of the database system to perform queries for a collection of business object data in the specified storage. &lt;p&gt; Requires READ permission on ALL namespaces &lt;/p&gt;
     * @param businessObjectDataDdlCollectionRequest the business object data DDL collection request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataGenerateBusinessObjectDataDdlCollection(businessObjectDataDdlCollectionRequest: BusinessObjectDataDdlCollectionRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataDdlCollectionResponse>;
    businessObjectDataGenerateBusinessObjectDataDdlCollection(businessObjectDataDdlCollectionRequest: BusinessObjectDataDdlCollectionRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataDdlCollectionResponse>>;
    businessObjectDataGenerateBusinessObjectDataDdlCollection(businessObjectDataDdlCollectionRequest: BusinessObjectDataDdlCollectionRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataDdlCollectionResponse>>;
    /**
     * generateBusinessObjectDataPartitions
     * Generates the partitions information for a range of requested business object data in the specified storage.
     * @param businessObjectDataPartitionsRequest the business object data partitions request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataGenerateBusinessObjectDataPartitions(businessObjectDataPartitionsRequest: BusinessObjectDataPartitionsRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataPartitions>;
    businessObjectDataGenerateBusinessObjectDataPartitions(businessObjectDataPartitionsRequest: BusinessObjectDataPartitionsRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataPartitions>>;
    businessObjectDataGenerateBusinessObjectDataPartitions(businessObjectDataPartitionsRequest: BusinessObjectDataPartitionsRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataPartitions>>;
    /**
     * getAllBusinessObjectDataByBusinessObjectDefinition
     * Retrieves a list of keys for all existing business object data up to the limit configured in the system for all latest business object format versions registered under specified business object definition. &lt;p&gt; Results are sorted alphabetically by primary and sub-partition values descending. &lt;/p&gt; &lt;p&gt; The limit on how many records this endpoint returns is set by \&quot;business.object.data.search.max.results.per.page\&quot; configuration value. &lt;/p&gt; &lt;p&gt; Requires READ permission on namespace. &lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectDefinition(namespace: string, businessObjectDefinitionName: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataKeys>;
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectDefinition(namespace: string, businessObjectDefinitionName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataKeys>>;
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectDefinition(namespace: string, businessObjectDefinitionName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataKeys>>;
    /**
     * getAllBusinessObjectDataByBusinessObjectDefinitionWithPagination
     * Retrieves a list of keys for all existing business object data registered under specified business object definition. &lt;p&gt; Results are sorted in descending order by business object data registration date (the latest data returned first). &lt;/p&gt; &lt;p&gt; NOTE: Page size is configured in the system and cannot be specified by the users as part of the request. Due to implementation, the data set returned for each page can be less than configured page size. &lt;/p&gt; &lt;p&gt; The response contains the following HTTP headers: &lt;ul&gt; &lt;li&gt; Paging-MaxResultsPerPage - the HTTP header for the maximum number of results that will be returned on any page of data. This is equal to the page size. &lt;/li&gt; &lt;li&gt; Paging-PageCount - the HTTP header for the total number of pages that exist assuming a page size limit and the total records returned in the query. &lt;/li&gt; &lt;li&gt; Paging-PageNum - the HTTP header for the current page number being returned. For the first page, this value would be \&quot;1\&quot;. &lt;/li&gt; &lt;li&gt; Paging-PageSize - the HTTP header for the current page size limit. This is configured by the system and cannot be set by the user. &lt;/li&gt; &lt;li&gt; Paging-TotalRecordCount - the HTTP header for the total number of records that would be returned across all pages. This is basically a \&quot;select count\&quot; query. &lt;/li&gt; &lt;li&gt; Paging-TotalRecordsOnPage - the HTTP header for the total number of records returned on the current page. This can be less than the page size. &lt;/li&gt; &lt;/ul&gt; &lt;/p&gt; &lt;p&gt; Requires READ permission on namespace. &lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name (case-insensitive)
     * @param pageNum the page number. If this parameter is specified, results contain the appropriate page that is specified. Page numbers are one-based - that is the first page number is one. Default value is 1
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectDefinitionWithPagination(namespace: string, businessObjectDefinitionName: string, pageNum?: number, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataKeys>;
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectDefinitionWithPagination(namespace: string, businessObjectDefinitionName: string, pageNum?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataKeys>>;
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectDefinitionWithPagination(namespace: string, businessObjectDefinitionName: string, pageNum?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataKeys>>;
    /**
     * getAllBusinessObjectDataByBusinessObjectFormat
     * Retrieves a list of keys for all existing business object data up to the limit configured in the system per specified business object format. &lt;p&gt; Results are sorted alphabetically by primary and sub-partition values descending. &lt;/p&gt; &lt;p&gt; The limit on how many records this endpoint returns is set by \&quot;business.object.data.search.max.results.per.page\&quot; configuration value. &lt;/p&gt; &lt;p&gt; Requires READ permission on namespace. &lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectFormat(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataKeys>;
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectFormat(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataKeys>>;
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectFormat(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataKeys>>;
    /**
     * getAllBusinessObjectDataByBusinessObjectFormatWithPagination
     * Retrieves a list of keys for all existing business object data registered under specified business object format version. &lt;p&gt; Results are sorted in descending order by business object data registration date (the latest data returned first). &lt;/p&gt; &lt;p&gt; NOTE: Page size is configured in the system and cannot be specified by the users as part of the request. Due to implementation, the data set returned for each page can be less then configured page size. &lt;/p&gt; &lt;p&gt; The response contains the following HTTP headers: &lt;ul&gt; &lt;li&gt; Paging-MaxResultsPerPage - the HTTP header for the maximum number of results that will be returned on any page of data. This is equal to the page size. &lt;/li&gt; &lt;li&gt; Paging-PageCount - the HTTP header for the total number of pages that exist assuming a page size limit and the total records returned in the query. &lt;/li&gt; &lt;li&gt; Paging-PageNum - the HTTP header for the current page number being returned. For the first page, this value would be \&quot;1\&quot;. &lt;/li&gt; &lt;li&gt; Paging-PageSize - the HTTP header for the current page size limit. This is configured by the system and cannot be set by the user. &lt;/li&gt; &lt;li&gt; Paging-TotalRecordCount - the HTTP header for the total number of records that would be returned across all pages. This is basically a \&quot;select count\&quot; query. &lt;/li&gt; &lt;li&gt; Paging-TotalRecordsOnPage - the HTTP header for the total number of records returned on the current page. This can be less than the page size. &lt;/li&gt; &lt;/ul&gt; &lt;/p&gt; &lt;p&gt; Requires READ permission on namespace. &lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param pageNum the page number. If this parameter is specified, results contain the appropriate page that is specified. Page numbers are one-based - that is the first page number is one. Default value is 1
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectFormatWithPagination(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, pageNum?: number, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataKeys>;
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectFormatWithPagination(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, pageNum?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataKeys>>;
    businessObjectDataGetAllBusinessObjectDataByBusinessObjectFormatWithPagination(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, pageNum?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataKeys>>;
    /**
     * getBusinessObjectData
     * Retrieves existing business object data entry information. &lt;p/&gt; NOTE: When both business object format version and business object data version are not specified, the business object format version has the precedence. The latest business object format version is determined by a sub-query, which does the following: &lt;p&gt; &lt;ul&gt; &lt;li&gt;selects all available data for the specified business object format (disregarding business object format version), partition values, and business object data status (default is \&quot;VALID\&quot;) &lt;li&gt;gets the latest business object format version from the records selected in the previous step &lt;/ul&gt; &lt;p&gt; &lt;p&gt; Requires READ permission on namespace &lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param partitionKey the partition key of the business object format. When specified, the partition key is validated against the partition key associated with the relative business object format
     * @param partitionValue the partition value of the business object data
     * @param subPartitionValues the list of sub-partition values delimited by \&quot;|\&quot; (delimiter can be escaped by \&quot;\\\&quot;)
     * @param businessObjectFormatVersion the version of the business object format. When the business object format version is not specified, the business object data with the latest business format version available for the specified partition values is returned
     * @param businessObjectDataVersion the version of the business object data. When business object data version is not specified, the latest version of business object data of the specified business object data status is returned
     * @param businessObjectDataStatus the status of the business object data. When business object data version is specified, this parameter is ignored. Default value is \&quot;VALID\&quot;
     * @param includeBusinessObjectDataStatusHistory specifies to include business object data status history in the response
     * @param includeStorageUnitStatusHistory specifies to include storage unit status history for each storage unit in the response
     * @param excludeBusinessObjectDataStorageFiles specifies to exclude storage files in the response
     * @param excludeLineageInformation specifies to exclude lineage information in the response
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataGetBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, partitionKey?: string, partitionValue?: string, subPartitionValues?: string, businessObjectFormatVersion?: number, businessObjectDataVersion?: number, businessObjectDataStatus?: string, includeBusinessObjectDataStatusHistory?: boolean, includeStorageUnitStatusHistory?: boolean, excludeBusinessObjectDataStorageFiles?: boolean, excludeLineageInformation?: boolean, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataGetBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, partitionKey?: string, partitionValue?: string, subPartitionValues?: string, businessObjectFormatVersion?: number, businessObjectDataVersion?: number, businessObjectDataStatus?: string, includeBusinessObjectDataStatusHistory?: boolean, includeStorageUnitStatusHistory?: boolean, excludeBusinessObjectDataStorageFiles?: boolean, excludeLineageInformation?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataGetBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, partitionKey?: string, partitionValue?: string, subPartitionValues?: string, businessObjectFormatVersion?: number, businessObjectDataVersion?: number, businessObjectDataStatus?: string, includeBusinessObjectDataStatusHistory?: boolean, includeStorageUnitStatusHistory?: boolean, excludeBusinessObjectDataStorageFiles?: boolean, excludeLineageInformation?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * getBusinessObjectDataVersions
     * Retrieves a list of existing business object data versions. &lt;p&gt; Requires READ permission on namespace &lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param partitionValue the partition value
     * @param subPartitionValues the list of sub-partition values
     * @param businessObjectFormatVersion the business object format version
     * @param businessObjectDataVersion the business object data version
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataGetBusinessObjectDataVersions(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, partitionValue?: string, subPartitionValues?: string, businessObjectFormatVersion?: number, businessObjectDataVersion?: number, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataVersions>;
    businessObjectDataGetBusinessObjectDataVersions(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, partitionValue?: string, subPartitionValues?: string, businessObjectFormatVersion?: number, businessObjectDataVersion?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataVersions>>;
    businessObjectDataGetBusinessObjectDataVersions(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, partitionValue?: string, subPartitionValues?: string, businessObjectFormatVersion?: number, businessObjectDataVersion?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataVersions>>;
    /**
     * Gets the S3 key prefix information for a specified namespace
     * &lt;p&gt; Gets the S3 key prefix for writing or accessing business object data. &lt;/p&gt; &lt;p&gt; This endpoint requires a namespace. &lt;/p&gt; &lt;p&gt; Requires READ permission on namespace &lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionKey the partition key
     * @param partitionValue the partition value
     * @param subPartitionValues the list of sub-partition values
     * @param businessObjectDataVersion the business object data version
     * @param storageName the storage name
     * @param createNewVersion Whether a new business object data can be created
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataGetS3KeyPrefix(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionKey?: string, partitionValue?: string, subPartitionValues?: string, businessObjectDataVersion?: number, storageName?: string, createNewVersion?: boolean, observe?: 'body', reportProgress?: boolean): Observable<S3KeyPrefixInformation>;
    businessObjectDataGetS3KeyPrefix(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionKey?: string, partitionValue?: string, subPartitionValues?: string, businessObjectDataVersion?: number, storageName?: string, createNewVersion?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<S3KeyPrefixInformation>>;
    businessObjectDataGetS3KeyPrefix(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionKey?: string, partitionValue?: string, subPartitionValues?: string, businessObjectDataVersion?: number, storageName?: string, createNewVersion?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<S3KeyPrefixInformation>>;
    /**
     * invalidateUnregisteredBusinessObjectData
     * Registers data as INVALID for objects which exist in S3 but are not registered in herd. &lt;p&gt; Requires WRITE permission on namespace &lt;/p&gt;
     * @param businessObjectDataInvalidateUnregisteredRequest the business object data invalidate un-register request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataInvalidateUnregisteredBusinessObjectData(businessObjectDataInvalidateUnregisteredRequest: BusinessObjectDataInvalidateUnregisteredRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataInvalidateUnregisteredResponse>;
    businessObjectDataInvalidateUnregisteredBusinessObjectData(businessObjectDataInvalidateUnregisteredRequest: BusinessObjectDataInvalidateUnregisteredRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataInvalidateUnregisteredResponse>>;
    businessObjectDataInvalidateUnregisteredBusinessObjectData(businessObjectDataInvalidateUnregisteredRequest: BusinessObjectDataInvalidateUnregisteredRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataInvalidateUnregisteredResponse>>;
    /**
     * restoreBusinessObjectData
     * Initiates a restore request for a currently archived business object data.
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the version of the business object format
     * @param partitionValue the primary partition value of the business object data
     * @param businessObjectDataVersion the version of the business object data
     * @param subPartitionValues the list of sub-partition values delimited by \&quot;|\&quot; (delimiter can be escaped by \&quot;\\\&quot;)
     * @param expirationInDays the time, in days, between when the business object data is restored to the S3 bucket and when it expires
     * @param archiveRetrievalOption the archive retrieval option when restoring an archived object. Currently three options are supported: Expedited, Standard, and Bulk
     * @param batchMode the flag used to indicate that S3 Batch processing should be used to restore the business object
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataRestoreBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, subPartitionValues?: string, expirationInDays?: number, archiveRetrievalOption?: string, batchMode?: boolean, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataRestoreBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, subPartitionValues?: string, expirationInDays?: number, archiveRetrievalOption?: string, batchMode?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataRestoreBusinessObjectData(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, subPartitionValues?: string, expirationInDays?: number, archiveRetrievalOption?: string, batchMode?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * retryStoragePolicyTransition
     * Retries a storage policy transition by forcing re-initiation of the archiving process for the specified business object data that is still in progress of a valid archiving operation. This endpoint is designed to be run only after confirmation that the business object data is stuck due to an error during archiving.
     * @param namespace the namespace of the business object definition
     * @param businessObjectDefinitionName the name of the business object definition
     * @param businessObjectFormatUsage the usage of the business object format
     * @param businessObjectFormatFileType the file type of the business object format
     * @param businessObjectFormatVersion the version of the business object format
     * @param partitionValue the primary partition value of the business object data
     * @param businessObjectDataVersion the version of the business object data
     * @param businessObjectDataRetryStoragePolicyTransitionRequest the information needed to retry a storage policy transition
     * @param subPartitionValues the optional list of sub-partition values delimited by \&quot;|\&quot; (delimiter can be escaped by \&quot;\\\&quot;)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataRetryStoragePolicyTransition(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataRetryStoragePolicyTransitionRequest: BusinessObjectDataRetryStoragePolicyTransitionRequest, subPartitionValues?: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataRetryStoragePolicyTransition(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataRetryStoragePolicyTransitionRequest: BusinessObjectDataRetryStoragePolicyTransitionRequest, subPartitionValues?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataRetryStoragePolicyTransition(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataRetryStoragePolicyTransitionRequest: BusinessObjectDataRetryStoragePolicyTransitionRequest, subPartitionValues?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * searchBusinessObjectData
     * Searches business object data based on namespace, definition name, format usage, file type, and format version. &lt;p&gt; Namespace and definition name are required. &lt;/p&gt; &lt;p&gt; Requires READ permission on namespace &lt;/p&gt; &lt;p&gt; The response contains the following HTTP headers: &lt;ul&gt; &lt;li&gt;Paging-MaxResultsPerPage - the HTTP header for the maximum number of results that will be returned on any page of data. The \&quot;pageSize\&quot; query parameter should not be greater than this value or an HTTP status of 400 (Bad Request) error would be returned&lt;/li&gt; &lt;li&gt;Paging-PageCount - the HTTP header for the total number of pages that exist assuming a page size limit and the total records returned in the query&lt;/li&gt; &lt;li&gt;Paging-PageNum - the HTTP header for the current page number being returned. For the first page, this value would be \&quot;1\&quot;&lt;/li&gt; &lt;li&gt;Paging-PageSize - the HTTP header for the current page size limit. This is based on what is specified in the request \&quot;pageSize\&quot; query parameter&lt;/li&gt; &lt;li&gt;Paging-TotalRecordsOnPage - the HTTP header for the total number of records returned on the current page. This could be less than the \&quot;pageSize\&quot; query parameter on the last page of data&lt;/li&gt; &lt;li&gt;Paging-TotalRecordCount - the HTTP header for the total number of records that would be returned across all pages. This is basically a \&quot;select count\&quot; query&lt;/li&gt; &lt;/ul&gt; &lt;/p&gt;
     * @param businessObjectDataSearchRequest the business object data search request
     * @param pageNum the page number. If this parameter is specified, results contain the appropriate page that is specified. Page numbers are one-based - that is the first page number is one. Default value is 1
     * @param pageSize the page size. If pageSize parameter is specified, results contain that number of business object data (unless it is the end of the result set). Default value is 1000
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataSearchBusinessObjectData(businessObjectDataSearchRequest: BusinessObjectDataSearchRequest, pageNum?: number, pageSize?: number, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataSearchResult>;
    businessObjectDataSearchBusinessObjectData(businessObjectDataSearchRequest: BusinessObjectDataSearchRequest, pageNum?: number, pageSize?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataSearchResult>>;
    businessObjectDataSearchBusinessObjectData(businessObjectDataSearchRequest: BusinessObjectDataSearchRequest, pageNum?: number, pageSize?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataSearchResult>>;
    /**
     * updateBusinessObjectDataAttributes
     * Updates attributes for the business object data without subpartition values. &lt;p&gt;Requires WRITE or WRITE_ATTRIBUTE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the partition value of the business object data
     * @param businessObjectDataVersion the business object data version
     * @param businessObjectDataAttributesUpdateRequest the information needed to update the business object data attributes
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataUpdateBusinessObjectDataAttributes(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataUpdateBusinessObjectDataAttributes(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataUpdateBusinessObjectDataAttributes(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * updateBusinessObjectDataAttributes
     * Updates attributes for the business object data with 1 subpartition value. &lt;p&gt;Requires WRITE or WRITE_ATTRIBUTE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the primary partition value of the business object data
     * @param subPartition1Value the 1st subpartition value of the business object data
     * @param businessObjectDataVersion the business object data version
     * @param businessObjectDataAttributesUpdateRequest the information needed to update the business object data attributes
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataUpdateBusinessObjectDataAttributes1(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataUpdateBusinessObjectDataAttributes1(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataUpdateBusinessObjectDataAttributes1(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * updateBusinessObjectDataAttributes
     * Updates attributes for the business object data with 2 subpartition values. &lt;p&gt;Requires WRITE or WRITE_ATTRIBUTE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the primary partition value of the business object data
     * @param subPartition1Value the 1st subpartition value of the business object data
     * @param subPartition2Value the 2nd subpartition value of the business object data
     * @param businessObjectDataVersion the business object data version
     * @param businessObjectDataAttributesUpdateRequest the information needed to update the business object data attributes
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataUpdateBusinessObjectDataAttributes2(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataUpdateBusinessObjectDataAttributes2(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataUpdateBusinessObjectDataAttributes2(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * updateBusinessObjectDataAttributes
     * Updates attributes for the business object data with 3 subpartition values. &lt;p&gt;Requires WRITE or WRITE_ATTRIBUTE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the primary partition value of the business object data
     * @param subPartition1Value the 1st subpartition value of the business object data
     * @param subPartition2Value the 2nd subpartition value of the business object data
     * @param subPartition3Value the 3rd subpartition value of the business object data
     * @param businessObjectDataVersion the business object data version
     * @param businessObjectDataAttributesUpdateRequest the information needed to update the business object data attributes
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataUpdateBusinessObjectDataAttributes3(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataUpdateBusinessObjectDataAttributes3(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataUpdateBusinessObjectDataAttributes3(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * updateBusinessObjectDataAttributes
     * Updates attributes for the business object data with 4 subpartition values. &lt;p&gt;Requires WRITE or WRITE_ATTRIBUTE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the primary partition value of the business object data
     * @param subPartition1Value the 1st subpartition value of the business object data
     * @param subPartition2Value the 2nd subpartition value of the business object data
     * @param subPartition3Value the 3rd subpartition value of the business object data
     * @param subPartition4Value the 4th subpartition value of the business object data
     * @param businessObjectDataVersion the business object data version
     * @param businessObjectDataAttributesUpdateRequest the information needed to update the business object data attributes
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataUpdateBusinessObjectDataAttributes4(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, subPartition4Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataUpdateBusinessObjectDataAttributes4(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, subPartition4Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataUpdateBusinessObjectDataAttributes4(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, subPartition4Value: string, businessObjectDataVersion: number, businessObjectDataAttributesUpdateRequest: BusinessObjectDataAttributesUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * updateBusinessObjectDataLegalHold
     * Updates legal hold status for an existing business object data by alternate key. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the name of the business object definition
     * @param businessObjectFormatUsage the usage of the business object format
     * @param businessObjectFormatFileType the file type of the business object format
     * @param businessObjectFormatVersion the version of the business object format
     * @param partitionValue the primary partition value
     * @param businessObjectDataVersion the version of the business object data
     * @param businessObjectDataLegalHoldUpdateRequest the information needed to update parents of the business object data
     * @param subPartitionValues the list of sub-partition values delimited by \&quot;|\&quot; (delimiter can be escaped by \&quot;\\\&quot;)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataUpdateBusinessObjectDataLegalHold(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataLegalHoldUpdateRequest: BusinessObjectDataLegalHoldUpdateRequest, subPartitionValues?: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataUpdateBusinessObjectDataLegalHold(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataLegalHoldUpdateRequest: BusinessObjectDataLegalHoldUpdateRequest, subPartitionValues?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataUpdateBusinessObjectDataLegalHold(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataLegalHoldUpdateRequest: BusinessObjectDataLegalHoldUpdateRequest, subPartitionValues?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * updateBusinessObjectDataParents
     * Updates parents information for an existing business object data by alternate key. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the name of the business object definition
     * @param businessObjectFormatUsage the usage of the business object format
     * @param businessObjectFormatFileType the file type of the business object format
     * @param businessObjectFormatVersion the version of the business object format
     * @param partitionValue the primary partition value
     * @param businessObjectDataVersion the version of the business object data
     * @param businessObjectDataParentsUpdateRequest the information needed to update parents of the business object data
     * @param subPartitionValues the list of sub-partition values delimited by \&quot;|\&quot; (delimiter can be escaped by \&quot;\\\&quot;)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataUpdateBusinessObjectDataParents(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataParentsUpdateRequest: BusinessObjectDataParentsUpdateRequest, subPartitionValues?: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataUpdateBusinessObjectDataParents(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataParentsUpdateRequest: BusinessObjectDataParentsUpdateRequest, subPartitionValues?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataUpdateBusinessObjectDataParents(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataParentsUpdateRequest: BusinessObjectDataParentsUpdateRequest, subPartitionValues?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
    /**
     * updateBusinessObjectDataRetentionInformation
     * Updates retention information for an existing business object data. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace of the business object definition
     * @param businessObjectDefinitionName the name of the business object definition
     * @param businessObjectFormatUsage the usage of the business object format
     * @param businessObjectFormatFileType the file type of the business object format
     * @param businessObjectFormatVersion the version of the business object format
     * @param partitionValue the primary partition value
     * @param businessObjectDataVersion the version of the business object data
     * @param businessObjectDataRetentionInformationUpdateRequest the business object data retention information update request
     * @param subPartitionValues the list of sub-partition values delimited by \&quot;|\&quot; (delimiter can be escaped by \&quot;\\\&quot;)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataUpdateBusinessObjectDataRetentionInformation(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataRetentionInformationUpdateRequest: BusinessObjectDataRetentionInformationUpdateRequest, subPartitionValues?: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectData>;
    businessObjectDataUpdateBusinessObjectDataRetentionInformation(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataRetentionInformationUpdateRequest: BusinessObjectDataRetentionInformationUpdateRequest, subPartitionValues?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectData>>;
    businessObjectDataUpdateBusinessObjectDataRetentionInformation(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataRetentionInformationUpdateRequest: BusinessObjectDataRetentionInformationUpdateRequest, subPartitionValues?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectData>>;
}
