/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { BusinessObjectDataNotificationRegistration } from '../model/businessObjectDataNotificationRegistration';
import { BusinessObjectDataNotificationRegistrationCreateRequest } from '../model/businessObjectDataNotificationRegistrationCreateRequest';
import { BusinessObjectDataNotificationRegistrationKeys } from '../model/businessObjectDataNotificationRegistrationKeys';
import { BusinessObjectDataNotificationRegistrationSearchRequest } from '../model/businessObjectDataNotificationRegistrationSearchRequest';
import { BusinessObjectDataNotificationRegistrationSearchResponse } from '../model/businessObjectDataNotificationRegistrationSearchResponse';
import { BusinessObjectDataNotificationRegistrationUpdateRequest } from '../model/businessObjectDataNotificationRegistrationUpdateRequest';
import { Configuration } from '../configuration';
export declare class BusinessObjectDataNotificationRegistrationService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createBusinessObjectDataNotificationRegistration
     * Creates a new business object data notification. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt; &lt;p&gt;Requires READ permission on filter namespace&lt;/p&gt; &lt;p&gt;Requires EXECUTE permission on ALL job action namespaces&lt;/p&gt;
     * @param businessObjectDataNotificationRegistrationCreateRequest the information needed to create the business object data notification
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataNotificationRegistrationCreateBusinessObjectDataNotificationRegistration(businessObjectDataNotificationRegistrationCreateRequest: BusinessObjectDataNotificationRegistrationCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataNotificationRegistration>;
    businessObjectDataNotificationRegistrationCreateBusinessObjectDataNotificationRegistration(businessObjectDataNotificationRegistrationCreateRequest: BusinessObjectDataNotificationRegistrationCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataNotificationRegistration>>;
    businessObjectDataNotificationRegistrationCreateBusinessObjectDataNotificationRegistration(businessObjectDataNotificationRegistrationCreateRequest: BusinessObjectDataNotificationRegistrationCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataNotificationRegistration>>;
    /**
     * deleteBusinessObjectDataNotification
     * Deletes an existing business object data notification by key. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param notificationName the business object data notification name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataNotificationRegistrationDeleteBusinessObjectDataNotification(namespace: string, notificationName: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataNotificationRegistration>;
    businessObjectDataNotificationRegistrationDeleteBusinessObjectDataNotification(namespace: string, notificationName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataNotificationRegistration>>;
    businessObjectDataNotificationRegistrationDeleteBusinessObjectDataNotification(namespace: string, notificationName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataNotificationRegistration>>;
    /**
     * getBusinessObjectDataNotificationRegistration
     * Gets an existing business object data notification by key. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param notificationName the business object data notification name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataNotificationRegistrationGetBusinessObjectDataNotificationRegistration(namespace: string, notificationName: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataNotificationRegistration>;
    businessObjectDataNotificationRegistrationGetBusinessObjectDataNotificationRegistration(namespace: string, notificationName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataNotificationRegistration>>;
    businessObjectDataNotificationRegistrationGetBusinessObjectDataNotificationRegistration(namespace: string, notificationName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataNotificationRegistration>>;
    /**
     * getBusinessObjectDataNotificationRegistrationsByNamespace
     * Gets a list of keys for all existing business object data notification registrations for the specified business object data notification registration namespace.
     * @param namespace the namespace of the business object data notification registration
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataNotificationRegistrationGetBusinessObjectDataNotificationRegistrationsByNamespace(namespace: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataNotificationRegistrationKeys>;
    businessObjectDataNotificationRegistrationGetBusinessObjectDataNotificationRegistrationsByNamespace(namespace: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataNotificationRegistrationKeys>>;
    businessObjectDataNotificationRegistrationGetBusinessObjectDataNotificationRegistrationsByNamespace(namespace: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataNotificationRegistrationKeys>>;
    /**
     * getBusinessObjectDataNotificationRegistrationsByNotificationFilter
     * &lt;p&gt; Gets a list of keys for all existing business object data notification registrations that match the specified business object data notification filter parameters. &lt;/p&gt; &lt;p&gt; This endpoint requires both namespace and name of the business object definition. &lt;/p&gt; &lt;p&gt;Requires READ permission on business object definition namespace&lt;/p&gt;
     * @param businessObjectDefinitionNamespace the namespace of the business object definition
     * @param businessObjectDefinitionName the name of the business object definition
     * @param businessObjectFormatUsage the usage of the business object format
     * @param businessObjectFormatFileType the file type of the business object format
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataNotificationRegistrationGetBusinessObjectDataNotificationRegistrationsByNotificationFilter(businessObjectDefinitionNamespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage?: string, businessObjectFormatFileType?: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataNotificationRegistrationKeys>;
    businessObjectDataNotificationRegistrationGetBusinessObjectDataNotificationRegistrationsByNotificationFilter(businessObjectDefinitionNamespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage?: string, businessObjectFormatFileType?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataNotificationRegistrationKeys>>;
    businessObjectDataNotificationRegistrationGetBusinessObjectDataNotificationRegistrationsByNotificationFilter(businessObjectDefinitionNamespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage?: string, businessObjectFormatFileType?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataNotificationRegistrationKeys>>;
    /**
     * searchBusinessObjectDataNotificationRegistrations
     * Retrieves all business object data notification registrations existing in the system per specified search filters and keys. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param businessObjectDataNotificationRegistrationSearchRequest the business object data notification registration search request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataNotificationRegistrationSearchBusinessObjectDataNotificationRegistrations(businessObjectDataNotificationRegistrationSearchRequest: BusinessObjectDataNotificationRegistrationSearchRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataNotificationRegistrationSearchResponse>;
    businessObjectDataNotificationRegistrationSearchBusinessObjectDataNotificationRegistrations(businessObjectDataNotificationRegistrationSearchRequest: BusinessObjectDataNotificationRegistrationSearchRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataNotificationRegistrationSearchResponse>>;
    businessObjectDataNotificationRegistrationSearchBusinessObjectDataNotificationRegistrations(businessObjectDataNotificationRegistrationSearchRequest: BusinessObjectDataNotificationRegistrationSearchRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataNotificationRegistrationSearchResponse>>;
    /**
     * updateBusinessObjectDataNotificationRegistration
     * Updates an existing business object data notification by key. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt; &lt;p&gt;Requires READ permission on filter namespace&lt;/p&gt; &lt;p&gt;Requires EXECUTE permission on ALL job action namespaces&lt;/p&gt;
     * @param namespace the namespace
     * @param notificationName the business object data notification name
     * @param businessObjectDataNotificationRegistrationUpdateRequest the information needed to update the business object data notification
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataNotificationRegistrationUpdateBusinessObjectDataNotificationRegistration(namespace: string, notificationName: string, businessObjectDataNotificationRegistrationUpdateRequest: BusinessObjectDataNotificationRegistrationUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataNotificationRegistration>;
    businessObjectDataNotificationRegistrationUpdateBusinessObjectDataNotificationRegistration(namespace: string, notificationName: string, businessObjectDataNotificationRegistrationUpdateRequest: BusinessObjectDataNotificationRegistrationUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataNotificationRegistration>>;
    businessObjectDataNotificationRegistrationUpdateBusinessObjectDataNotificationRegistration(namespace: string, notificationName: string, businessObjectDataNotificationRegistrationUpdateRequest: BusinessObjectDataNotificationRegistrationUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataNotificationRegistration>>;
}
