/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { BusinessObjectDataStatusInformation } from '../model/businessObjectDataStatusInformation';
import { BusinessObjectDataStatusUpdateRequest } from '../model/businessObjectDataStatusUpdateRequest';
import { BusinessObjectDataStatusUpdateResponse } from '../model/businessObjectDataStatusUpdateResponse';
import { Configuration } from '../configuration';
export declare class BusinessObjectDataStatusService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * getBusinessObjectDataStatus
     * Retrieves status information for an existing business object data. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param partitionKey the business object format partition key.
     * @param partitionValue the partition value
     * @param subPartitionValues the list of sub-partition values
     * @param businessObjectFormatVersion the business object format version
     * @param businessObjectDataVersion the business object data version
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataStatusGetBusinessObjectDataStatus(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, partitionKey?: string, partitionValue?: string, subPartitionValues?: string, businessObjectFormatVersion?: number, businessObjectDataVersion?: number, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataStatusInformation>;
    businessObjectDataStatusGetBusinessObjectDataStatus(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, partitionKey?: string, partitionValue?: string, subPartitionValues?: string, businessObjectFormatVersion?: number, businessObjectDataVersion?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataStatusInformation>>;
    businessObjectDataStatusGetBusinessObjectDataStatus(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, partitionKey?: string, partitionValue?: string, subPartitionValues?: string, businessObjectFormatVersion?: number, businessObjectDataVersion?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataStatusInformation>>;
    /**
     * updateBusinessObjectDataStatus
     * Updates status of a business object data without subpartition values. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the partition value
     * @param businessObjectDataVersion the business object data version
     * @param businessObjectDataStatusUpdateRequest the business object data status update request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataStatusUpdateBusinessObjectDataStatus(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataStatusUpdateResponse>;
    businessObjectDataStatusUpdateBusinessObjectDataStatus(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataStatusUpdateResponse>>;
    businessObjectDataStatusUpdateBusinessObjectDataStatus(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataStatusUpdateResponse>>;
    /**
     * updateBusinessObjectDataStatus
     * Updates status of a business object data with 1 subpartition values. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the partition value
     * @param subPartition1Value the value of the first subpartition
     * @param businessObjectDataVersion the business object data version
     * @param businessObjectDataStatusUpdateRequest the business object data status update request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataStatusUpdateBusinessObjectDataStatus1(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataStatusUpdateResponse>;
    businessObjectDataStatusUpdateBusinessObjectDataStatus1(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataStatusUpdateResponse>>;
    businessObjectDataStatusUpdateBusinessObjectDataStatus1(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataStatusUpdateResponse>>;
    /**
     * updateBusinessObjectDataStatus
     * Updates status of a business object data with 2 subpartition values. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the partition value
     * @param subPartition1Value the value of the first subpartition
     * @param subPartition2Value the value of the second subpartition
     * @param businessObjectDataVersion the business object data version
     * @param businessObjectDataStatusUpdateRequest the business object data status update request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataStatusUpdateBusinessObjectDataStatus2(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataStatusUpdateResponse>;
    businessObjectDataStatusUpdateBusinessObjectDataStatus2(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataStatusUpdateResponse>>;
    businessObjectDataStatusUpdateBusinessObjectDataStatus2(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataStatusUpdateResponse>>;
    /**
     * updateBusinessObjectDataStatus
     * Updates status of a business object data with 3 subpartition values. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the partition value
     * @param subPartition1Value the value of the first subpartition
     * @param subPartition2Value the value of the second subpartition
     * @param subPartition3Value the value of the third subpartition
     * @param businessObjectDataVersion the business object data version
     * @param businessObjectDataStatusUpdateRequest the business object data status update request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataStatusUpdateBusinessObjectDataStatus3(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataStatusUpdateResponse>;
    businessObjectDataStatusUpdateBusinessObjectDataStatus3(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataStatusUpdateResponse>>;
    businessObjectDataStatusUpdateBusinessObjectDataStatus3(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataStatusUpdateResponse>>;
    /**
     * updateBusinessObjectDataStatus
     * Updates status of a business object data with 4 subpartition values. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param partitionValue the partition value
     * @param subPartition1Value the value of the first subpartition
     * @param subPartition2Value the value of the second subpartition
     * @param subPartition3Value the value of the third subpartition
     * @param subPartition4Value the value of the forth subpartition
     * @param businessObjectDataVersion the business object data version
     * @param businessObjectDataStatusUpdateRequest the business object data status update request
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDataStatusUpdateBusinessObjectDataStatus4(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, subPartition4Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDataStatusUpdateResponse>;
    businessObjectDataStatusUpdateBusinessObjectDataStatus4(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, subPartition4Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDataStatusUpdateResponse>>;
    businessObjectDataStatusUpdateBusinessObjectDataStatus4(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, partitionValue: string, subPartition1Value: string, subPartition2Value: string, subPartition3Value: string, subPartition4Value: string, businessObjectDataVersion: number, businessObjectDataStatusUpdateRequest: BusinessObjectDataStatusUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDataStatusUpdateResponse>>;
}
