/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { BusinessObjectDefinitionColumn } from '../model/businessObjectDefinitionColumn';
import { BusinessObjectDefinitionColumnCreateRequest } from '../model/businessObjectDefinitionColumnCreateRequest';
import { BusinessObjectDefinitionColumnKeys } from '../model/businessObjectDefinitionColumnKeys';
import { BusinessObjectDefinitionColumnSearchRequest } from '../model/businessObjectDefinitionColumnSearchRequest';
import { BusinessObjectDefinitionColumnSearchResponse } from '../model/businessObjectDefinitionColumnSearchResponse';
import { BusinessObjectDefinitionColumnUpdateRequest } from '../model/businessObjectDefinitionColumnUpdateRequest';
import { Configuration } from '../configuration';
export declare class BusinessObjectDefinitionColumnService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createBusinessObjectDefinitionColumn
     * Creates a new business object definition column. &lt;p&gt;Requires WRITE or WRITE_DESCRIPTIVE_CONTENT permission on namespace&lt;/p&gt;
     * @param businessObjectDefinitionColumnCreateRequest the information needed to create a business object definition column
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDefinitionColumnCreateBusinessObjectDefinitionColumn(businessObjectDefinitionColumnCreateRequest: BusinessObjectDefinitionColumnCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDefinitionColumn>;
    businessObjectDefinitionColumnCreateBusinessObjectDefinitionColumn(businessObjectDefinitionColumnCreateRequest: BusinessObjectDefinitionColumnCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDefinitionColumn>>;
    businessObjectDefinitionColumnCreateBusinessObjectDefinitionColumn(businessObjectDefinitionColumnCreateRequest: BusinessObjectDefinitionColumnCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDefinitionColumn>>;
    /**
     * deleteBusinessObjectDefinitionColumn
     * Deletes an existing column for the business object definition. &lt;p&gt;Requires WRITE or WRITE_DESCRIPTIVE_CONTENT permission on namespace&lt;/p&gt;
     * @param namespace the namespace of the business object definition
     * @param businessObjectDefinitionName the name of the business object definition
     * @param businessObjectDefinitionColumnName the name of the business object definition column
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDefinitionColumnDeleteBusinessObjectDefinitionColumn(namespace: string, businessObjectDefinitionName: string, businessObjectDefinitionColumnName: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDefinitionColumn>;
    businessObjectDefinitionColumnDeleteBusinessObjectDefinitionColumn(namespace: string, businessObjectDefinitionName: string, businessObjectDefinitionColumnName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDefinitionColumn>>;
    businessObjectDefinitionColumnDeleteBusinessObjectDefinitionColumn(namespace: string, businessObjectDefinitionName: string, businessObjectDefinitionColumnName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDefinitionColumn>>;
    /**
     * getBusinessObjectDefinitionColumn
     * Gets an existing column for the business object definition.
     * @param namespace the namespace of the business object definition
     * @param businessObjectDefinitionName the name of the business object definition
     * @param businessObjectDefinitionColumnName the name of the business object definition column
     * @param includeBusinessObjectDefinitionColumnUpdateHistory the boolean flag to determine whether or not to include business object definition column update history in the get results
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDefinitionColumnGetBusinessObjectDefinitionColumn(namespace: string, businessObjectDefinitionName: string, businessObjectDefinitionColumnName: string, includeBusinessObjectDefinitionColumnUpdateHistory?: boolean, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDefinitionColumn>;
    businessObjectDefinitionColumnGetBusinessObjectDefinitionColumn(namespace: string, businessObjectDefinitionName: string, businessObjectDefinitionColumnName: string, includeBusinessObjectDefinitionColumnUpdateHistory?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDefinitionColumn>>;
    businessObjectDefinitionColumnGetBusinessObjectDefinitionColumn(namespace: string, businessObjectDefinitionName: string, businessObjectDefinitionColumnName: string, includeBusinessObjectDefinitionColumnUpdateHistory?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDefinitionColumn>>;
    /**
     * getBusinessObjectDefinitionColumns
     * Gets a list of keys for all existing business object definition columns for a specific business object definition.
     * @param namespace the namespace of the business object definition
     * @param businessObjectDefinitionName the name of the business object definition
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDefinitionColumnGetBusinessObjectDefinitionColumns(namespace: string, businessObjectDefinitionName: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDefinitionColumnKeys>;
    businessObjectDefinitionColumnGetBusinessObjectDefinitionColumns(namespace: string, businessObjectDefinitionName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDefinitionColumnKeys>>;
    businessObjectDefinitionColumnGetBusinessObjectDefinitionColumns(namespace: string, businessObjectDefinitionName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDefinitionColumnKeys>>;
    /**
     * searchBusinessObjectDefinitionColumns
     * Retrieve a list of business object definition columns meeting the search criteria filters and fields request.
     * @param businessObjectDefinitionColumnSearchRequest the search criteria needed to find a list of business object definition columns
     * @param fields the field options for the business object definition columns search response. The valid field options are: description, schemaColumnName
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDefinitionColumnSearchBusinessObjectDefinitionColumns(businessObjectDefinitionColumnSearchRequest: BusinessObjectDefinitionColumnSearchRequest, fields?: string, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDefinitionColumnSearchResponse>;
    businessObjectDefinitionColumnSearchBusinessObjectDefinitionColumns(businessObjectDefinitionColumnSearchRequest: BusinessObjectDefinitionColumnSearchRequest, fields?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDefinitionColumnSearchResponse>>;
    businessObjectDefinitionColumnSearchBusinessObjectDefinitionColumns(businessObjectDefinitionColumnSearchRequest: BusinessObjectDefinitionColumnSearchRequest, fields?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDefinitionColumnSearchResponse>>;
    /**
     * updateBusinessObjectDefinitionColumn
     * Updates an existing column for the business object definition. &lt;p&gt;Requires WRITE or WRITE_DESCRIPTIVE_CONTENT permission on namespace&lt;/p&gt;
     * @param namespace the namespace of the business object definition
     * @param businessObjectDefinitionName the name of the business object definition
     * @param businessObjectDefinitionColumnName the name of the business object definition column
     * @param businessObjectDefinitionColumnUpdateRequest the request information needed to update the business object definition column
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    businessObjectDefinitionColumnUpdateBusinessObjectDefinitionColumn(namespace: string, businessObjectDefinitionName: string, businessObjectDefinitionColumnName: string, businessObjectDefinitionColumnUpdateRequest: BusinessObjectDefinitionColumnUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<BusinessObjectDefinitionColumn>;
    businessObjectDefinitionColumnUpdateBusinessObjectDefinitionColumn(namespace: string, businessObjectDefinitionName: string, businessObjectDefinitionColumnName: string, businessObjectDefinitionColumnUpdateRequest: BusinessObjectDefinitionColumnUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BusinessObjectDefinitionColumn>>;
    businessObjectDefinitionColumnUpdateBusinessObjectDefinitionColumn(namespace: string, businessObjectDefinitionName: string, businessObjectDefinitionColumnName: string, businessObjectDefinitionColumnUpdateRequest: BusinessObjectDefinitionColumnUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BusinessObjectDefinitionColumn>>;
}
