/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { CustomDdl } from '../model/customDdl';
import { CustomDdlCreateRequest } from '../model/customDdlCreateRequest';
import { CustomDdlKeys } from '../model/customDdlKeys';
import { CustomDdlUpdateRequest } from '../model/customDdlUpdateRequest';
import { Configuration } from '../configuration';
export declare class CustomDDLService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createCustomDdl
     * Creates a new custom DDL. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param customDdlCreateRequest the information needed to create a custom DDL
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    customDDLCreateCustomDdl(customDdlCreateRequest: CustomDdlCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<CustomDdl>;
    customDDLCreateCustomDdl(customDdlCreateRequest: CustomDdlCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomDdl>>;
    customDDLCreateCustomDdl(customDdlCreateRequest: CustomDdlCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomDdl>>;
    /**
     * deleteCustomDdl
     * Deletes an existing custom DDL. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param customDdlName the custom DDL name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    customDDLDeleteCustomDdl(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, customDdlName: string, observe?: 'body', reportProgress?: boolean): Observable<CustomDdl>;
    customDDLDeleteCustomDdl(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, customDdlName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomDdl>>;
    customDDLDeleteCustomDdl(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, customDdlName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomDdl>>;
    /**
     * getCustomDdl
     * Gets an existing custom DDL. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param customDdlName the custom DDL name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    customDDLGetCustomDdl(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, customDdlName: string, observe?: 'body', reportProgress?: boolean): Observable<CustomDdl>;
    customDDLGetCustomDdl(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, customDdlName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomDdl>>;
    customDDLGetCustomDdl(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, customDdlName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomDdl>>;
    /**
     * getCustomDdls
     * Gets a list of keys for all existing custom DDLs for a specific business object format. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    customDDLGetCustomDdls(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, observe?: 'body', reportProgress?: boolean): Observable<CustomDdlKeys>;
    customDDLGetCustomDdls(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomDdlKeys>>;
    customDDLGetCustomDdls(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomDdlKeys>>;
    /**
     * updateCustomDdl
     * Updates an existing custom DDL. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param businessObjectDefinitionName the business object definition name
     * @param businessObjectFormatUsage the business object format usage
     * @param businessObjectFormatFileType the business object format file type
     * @param businessObjectFormatVersion the business object format version
     * @param customDdlName the custom DDL name
     * @param customDdlUpdateRequest the request information needed to update the custom DDL
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    customDDLUpdateCustomDdl(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, customDdlName: string, customDdlUpdateRequest: CustomDdlUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<CustomDdl>;
    customDDLUpdateCustomDdl(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, customDdlName: string, customDdlUpdateRequest: CustomDdlUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomDdl>>;
    customDDLUpdateCustomDdl(namespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage: string, businessObjectFormatFileType: string, businessObjectFormatVersion: number, customDdlName: string, customDdlUpdateRequest: CustomDdlUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomDdl>>;
}
