/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { EmrClusterDefinitionCreateRequest } from '../model/emrClusterDefinitionCreateRequest';
import { EmrClusterDefinitionInformation } from '../model/emrClusterDefinitionInformation';
import { EmrClusterDefinitionKeys } from '../model/emrClusterDefinitionKeys';
import { EmrClusterDefinitionUpdateRequest } from '../model/emrClusterDefinitionUpdateRequest';
import { Configuration } from '../configuration';
export declare class EMRClusterDefinitionService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createEmrClusterDefinition
     * Creates a new EMR cluster definition. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param emrClusterDefinitionCreateRequest the information needed to create an EMR cluster definition
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    eMRClusterDefinitionCreateEmrClusterDefinition(emrClusterDefinitionCreateRequest: EmrClusterDefinitionCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<EmrClusterDefinitionInformation>;
    eMRClusterDefinitionCreateEmrClusterDefinition(emrClusterDefinitionCreateRequest: EmrClusterDefinitionCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EmrClusterDefinitionInformation>>;
    eMRClusterDefinitionCreateEmrClusterDefinition(emrClusterDefinitionCreateRequest: EmrClusterDefinitionCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EmrClusterDefinitionInformation>>;
    /**
     * deleteEmrClusterDefinition
     * Deletes an existing EMR cluster definition by namespace and name. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param emrClusterDefinitionName the EMR cluster definition name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    eMRClusterDefinitionDeleteEmrClusterDefinition(namespace: string, emrClusterDefinitionName: string, observe?: 'body', reportProgress?: boolean): Observable<EmrClusterDefinitionInformation>;
    eMRClusterDefinitionDeleteEmrClusterDefinition(namespace: string, emrClusterDefinitionName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EmrClusterDefinitionInformation>>;
    eMRClusterDefinitionDeleteEmrClusterDefinition(namespace: string, emrClusterDefinitionName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EmrClusterDefinitionInformation>>;
    /**
     * getEmrClusterDefinition
     * Gets an existing EMR cluster definition by namespace and name. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param emrClusterDefinitionName the EMR cluster definition name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    eMRClusterDefinitionGetEmrClusterDefinition(namespace: string, emrClusterDefinitionName: string, observe?: 'body', reportProgress?: boolean): Observable<EmrClusterDefinitionInformation>;
    eMRClusterDefinitionGetEmrClusterDefinition(namespace: string, emrClusterDefinitionName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EmrClusterDefinitionInformation>>;
    eMRClusterDefinitionGetEmrClusterDefinition(namespace: string, emrClusterDefinitionName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EmrClusterDefinitionInformation>>;
    /**
     * getEmrClusterDefinitions
     * Gets a list of keys for all EMR cluster definitions defined in the system for the specified namespace. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    eMRClusterDefinitionGetEmrClusterDefinitions(namespace: string, observe?: 'body', reportProgress?: boolean): Observable<EmrClusterDefinitionKeys>;
    eMRClusterDefinitionGetEmrClusterDefinitions(namespace: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EmrClusterDefinitionKeys>>;
    eMRClusterDefinitionGetEmrClusterDefinitions(namespace: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EmrClusterDefinitionKeys>>;
    /**
     * updateEmrClusterDefinition
     * Updates an existing EMR cluster definition by namespace and name. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param emrClusterDefinitionName the EMR cluster definition name
     * @param emrClusterDefinitionUpdateRequest the information needed to update the EMR cluster definition
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    eMRClusterDefinitionUpdateEmrClusterDefinition(namespace: string, emrClusterDefinitionName: string, emrClusterDefinitionUpdateRequest: EmrClusterDefinitionUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<EmrClusterDefinitionInformation>;
    eMRClusterDefinitionUpdateEmrClusterDefinition(namespace: string, emrClusterDefinitionName: string, emrClusterDefinitionUpdateRequest: EmrClusterDefinitionUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EmrClusterDefinitionInformation>>;
    eMRClusterDefinitionUpdateEmrClusterDefinition(namespace: string, emrClusterDefinitionName: string, emrClusterDefinitionUpdateRequest: EmrClusterDefinitionUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EmrClusterDefinitionInformation>>;
}
