/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Namespace } from '../model/namespace';
import { NamespaceCreateRequest } from '../model/namespaceCreateRequest';
import { NamespaceDefaultRecordFlagUpdateRequest } from '../model/namespaceDefaultRecordFlagUpdateRequest';
import { NamespaceKeys } from '../model/namespaceKeys';
import { NamespaceSearchRequest } from '../model/namespaceSearchRequest';
import { NamespaceSearchResponse } from '../model/namespaceSearchResponse';
import { NamespaceUpdateRequest } from '../model/namespaceUpdateRequest';
import { Configuration } from '../configuration';
export declare class NamespaceService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createNamespace
     * Creates a new namespace.
     * @param namespaceCreateRequest the information needed to create the namespace
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    namespaceCreateNamespace(namespaceCreateRequest: NamespaceCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<Namespace>;
    namespaceCreateNamespace(namespaceCreateRequest: NamespaceCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Namespace>>;
    namespaceCreateNamespace(namespaceCreateRequest: NamespaceCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Namespace>>;
    /**
     * deleteNamespace
     * Deletes an existing namespace by namespace code.
     * @param namespaceCode the namespace code
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    namespaceDeleteNamespace(namespaceCode: string, observe?: 'body', reportProgress?: boolean): Observable<Namespace>;
    namespaceDeleteNamespace(namespaceCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Namespace>>;
    namespaceDeleteNamespace(namespaceCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Namespace>>;
    /**
     * getNamespace
     * Gets an existing namespace by namespace code.
     * @param namespaceCode the namespace code
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    namespaceGetNamespace(namespaceCode: string, observe?: 'body', reportProgress?: boolean): Observable<Namespace>;
    namespaceGetNamespace(namespaceCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Namespace>>;
    namespaceGetNamespace(namespaceCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Namespace>>;
    /**
     * getNamespaces
     * Gets a list of namespace keys for all namespaces defined in the system.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    namespaceGetNamespaces(observe?: 'body', reportProgress?: boolean): Observable<NamespaceKeys>;
    namespaceGetNamespaces(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<NamespaceKeys>>;
    namespaceGetNamespaces(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<NamespaceKeys>>;
    /**
     * searchNamespaces
     * Retrieves all namespaces existing in the system per specified search filters and keys.
     * @param namespaceSearchRequest the namespace search request. The request can only accept a single search filter and a single search key
     * @param fields the field options for the namespace search response. The valid field options are: chargeCode, s3KeyPrefix
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    namespaceSearchNamespaces(namespaceSearchRequest: NamespaceSearchRequest, fields?: string, observe?: 'body', reportProgress?: boolean): Observable<NamespaceSearchResponse>;
    namespaceSearchNamespaces(namespaceSearchRequest: NamespaceSearchRequest, fields?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<NamespaceSearchResponse>>;
    namespaceSearchNamespaces(namespaceSearchRequest: NamespaceSearchRequest, fields?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<NamespaceSearchResponse>>;
    /**
     * updateNamespaceDefaultRecordFlag
     * Updates an existing namespace.
     * @param namespaceCode
     * @param namespaceDefaultRecordFlagUpdateRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    namespaceUpdateNamespaceDefaultRecordFlag(namespaceCode: string, namespaceDefaultRecordFlagUpdateRequest: NamespaceDefaultRecordFlagUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<Namespace>;
    namespaceUpdateNamespaceDefaultRecordFlag(namespaceCode: string, namespaceDefaultRecordFlagUpdateRequest: NamespaceDefaultRecordFlagUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Namespace>>;
    namespaceUpdateNamespaceDefaultRecordFlag(namespaceCode: string, namespaceDefaultRecordFlagUpdateRequest: NamespaceDefaultRecordFlagUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Namespace>>;
    /**
     * updateNamespaces
     * Updates an existing namespace.
     * @param namespaceCode
     * @param namespaceUpdateRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    namespaceUpdateNamespaces(namespaceCode: string, namespaceUpdateRequest: NamespaceUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<Namespace>;
    namespaceUpdateNamespaces(namespaceCode: string, namespaceUpdateRequest: NamespaceUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Namespace>>;
    namespaceUpdateNamespaces(namespaceCode: string, namespaceUpdateRequest: NamespaceUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Namespace>>;
}
