/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { SecurityRole } from '../model/securityRole';
import { SecurityRoleCreateRequest } from '../model/securityRoleCreateRequest';
import { SecurityRoleKeys } from '../model/securityRoleKeys';
import { SecurityRoleUpdateRequest } from '../model/securityRoleUpdateRequest';
import { Configuration } from '../configuration';
export declare class SecurityRoleService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createSecurityRole
     * Creates a new security role.
     * @param securityRoleCreateRequest the information needed to create a security role
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    securityRoleCreateSecurityRole(securityRoleCreateRequest: SecurityRoleCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<SecurityRole>;
    securityRoleCreateSecurityRole(securityRoleCreateRequest: SecurityRoleCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SecurityRole>>;
    securityRoleCreateSecurityRole(securityRoleCreateRequest: SecurityRoleCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SecurityRole>>;
    /**
     * deleteSecurityRole
     * Deletes an existing security role.
     * @param securityRoleName the security role name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    securityRoleDeleteSecurityRole(securityRoleName: string, observe?: 'body', reportProgress?: boolean): Observable<SecurityRole>;
    securityRoleDeleteSecurityRole(securityRoleName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SecurityRole>>;
    securityRoleDeleteSecurityRole(securityRoleName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SecurityRole>>;
    /**
     * getSecurityRole
     * Retrieves an existing security role.
     * @param securityRoleName the security role name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    securityRoleGetSecurityRole(securityRoleName: string, observe?: 'body', reportProgress?: boolean): Observable<SecurityRole>;
    securityRoleGetSecurityRole(securityRoleName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SecurityRole>>;
    securityRoleGetSecurityRole(securityRoleName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SecurityRole>>;
    /**
     * getSecurityRoles
     * Gets a list of security role keys for all security roles registered in the system. The result list is sorted by security role name in ascending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    securityRoleGetSecurityRoles(observe?: 'body', reportProgress?: boolean): Observable<SecurityRoleKeys>;
    securityRoleGetSecurityRoles(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SecurityRoleKeys>>;
    securityRoleGetSecurityRoles(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SecurityRoleKeys>>;
    /**
     * updateSecurityRole
     * Updates an existing security role.
     * @param securityRoleName the security role name
     * @param securityRoleUpdateRequest the information required to update a security role
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    securityRoleUpdateSecurityRole(securityRoleName: string, securityRoleUpdateRequest: SecurityRoleUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<SecurityRole>;
    securityRoleUpdateSecurityRole(securityRoleName: string, securityRoleUpdateRequest: SecurityRoleUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SecurityRole>>;
    securityRoleUpdateSecurityRole(securityRoleName: string, securityRoleUpdateRequest: SecurityRoleUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SecurityRole>>;
}
