/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { SecurityRoleFunction } from '../model/securityRoleFunction';
import { SecurityRoleFunctionCreateRequest } from '../model/securityRoleFunctionCreateRequest';
import { SecurityRoleFunctionKeys } from '../model/securityRoleFunctionKeys';
import { Configuration } from '../configuration';
export declare class SecurityRoleToFunctionMappingService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createSecurityRoleFunction
     * Creates a new security role to function mapping that is identified by security role name and security function name.
     * @param securityRoleFunctionCreateRequest the information needed to create a security role to function mapping
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    securityRoleToFunctionMappingCreateSecurityRoleFunction(securityRoleFunctionCreateRequest: SecurityRoleFunctionCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<SecurityRoleFunction>;
    securityRoleToFunctionMappingCreateSecurityRoleFunction(securityRoleFunctionCreateRequest: SecurityRoleFunctionCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SecurityRoleFunction>>;
    securityRoleToFunctionMappingCreateSecurityRoleFunction(securityRoleFunctionCreateRequest: SecurityRoleFunctionCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SecurityRoleFunction>>;
    /**
     * deleteSecurityRoleFunction
     * Deletes an existing security role to function mapping based on the specified parameters.
     * @param securityRoleName the security role name
     * @param securityFunctionName the security function name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    securityRoleToFunctionMappingDeleteSecurityRoleFunction(securityRoleName: string, securityFunctionName: string, observe?: 'body', reportProgress?: boolean): Observable<SecurityRoleFunction>;
    securityRoleToFunctionMappingDeleteSecurityRoleFunction(securityRoleName: string, securityFunctionName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SecurityRoleFunction>>;
    securityRoleToFunctionMappingDeleteSecurityRoleFunction(securityRoleName: string, securityFunctionName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SecurityRoleFunction>>;
    /**
     * getSecurityRoleFunction
     * Retrieves an existing security role to function mapping based on the specified parameters.
     * @param securityRoleName the security role name
     * @param securityFunctionName the security function name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    securityRoleToFunctionMappingGetSecurityRoleFunction(securityRoleName: string, securityFunctionName: string, observe?: 'body', reportProgress?: boolean): Observable<SecurityRoleFunction>;
    securityRoleToFunctionMappingGetSecurityRoleFunction(securityRoleName: string, securityFunctionName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SecurityRoleFunction>>;
    securityRoleToFunctionMappingGetSecurityRoleFunction(securityRoleName: string, securityFunctionName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SecurityRoleFunction>>;
    /**
     * getSecurityRoleFunctions
     * Retrieves a list of security role to function mapping keys for all security role to function mappings registered in the system. The result list is sorted by security role name and security function name in ascending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    securityRoleToFunctionMappingGetSecurityRoleFunctions(observe?: 'body', reportProgress?: boolean): Observable<SecurityRoleFunctionKeys>;
    securityRoleToFunctionMappingGetSecurityRoleFunctions(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SecurityRoleFunctionKeys>>;
    securityRoleToFunctionMappingGetSecurityRoleFunctions(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SecurityRoleFunctionKeys>>;
    /**
     * getSecurityRoleFunctionsBySecurityFunction
     * Retrieves a list of security role to function mapping keys for the specified security function. The result list is sorted by security role name in ascending order.
     * @param securityFunctionName the security function name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    securityRoleToFunctionMappingGetSecurityRoleFunctionsBySecurityFunction(securityFunctionName: string, observe?: 'body', reportProgress?: boolean): Observable<SecurityRoleFunctionKeys>;
    securityRoleToFunctionMappingGetSecurityRoleFunctionsBySecurityFunction(securityFunctionName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SecurityRoleFunctionKeys>>;
    securityRoleToFunctionMappingGetSecurityRoleFunctionsBySecurityFunction(securityFunctionName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SecurityRoleFunctionKeys>>;
    /**
     * getSecurityRoleFunctionsBySecurityRole
     * Retrieves a list of security role to function mapping keys for the specified security role. The result list is sorted by security function name in ascending order.
     * @param securityRoleName the security role name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    securityRoleToFunctionMappingGetSecurityRoleFunctionsBySecurityRole(securityRoleName: string, observe?: 'body', reportProgress?: boolean): Observable<SecurityRoleFunctionKeys>;
    securityRoleToFunctionMappingGetSecurityRoleFunctionsBySecurityRole(securityRoleName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SecurityRoleFunctionKeys>>;
    securityRoleToFunctionMappingGetSecurityRoleFunctionsBySecurityRole(securityRoleName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SecurityRoleFunctionKeys>>;
}
