/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Storage } from '../model/storage';
import { StorageAttributesUpdateRequest } from '../model/storageAttributesUpdateRequest';
import { StorageCreateRequest } from '../model/storageCreateRequest';
import { StorageKeys } from '../model/storageKeys';
import { StorageUpdateRequest } from '../model/storageUpdateRequest';
import { Configuration } from '../configuration';
export declare class StorageService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createStorage
     * Creates a new storage.
     * @param storageCreateRequest the information needed to create the storage
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageCreateStorage(storageCreateRequest: StorageCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<Storage>;
    storageCreateStorage(storageCreateRequest: StorageCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Storage>>;
    storageCreateStorage(storageCreateRequest: StorageCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Storage>>;
    /**
     * deleteStorage
     * Deletes an existing storage by name.
     * @param storageName the storage name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageDeleteStorage(storageName: string, observe?: 'body', reportProgress?: boolean): Observable<Storage>;
    storageDeleteStorage(storageName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Storage>>;
    storageDeleteStorage(storageName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Storage>>;
    /**
     * getStorage
     * Gets an existing storage by name.
     * @param storageName the storage name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageGetStorage(storageName: string, observe?: 'body', reportProgress?: boolean): Observable<Storage>;
    storageGetStorage(storageName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Storage>>;
    storageGetStorage(storageName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Storage>>;
    /**
     * getStorages
     * Gets a list of storage keys for all storage defined in the system.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageGetStorages(observe?: 'body', reportProgress?: boolean): Observable<StorageKeys>;
    storageGetStorages(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StorageKeys>>;
    storageGetStorages(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StorageKeys>>;
    /**
     * updateStorage
     * Updates an existing storage.
     * @param storageName the name of the storage to update
     * @param storageUpdateRequest the information needed to update the storage
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageUpdateStorage(storageName: string, storageUpdateRequest: StorageUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<Storage>;
    storageUpdateStorage(storageName: string, storageUpdateRequest: StorageUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Storage>>;
    storageUpdateStorage(storageName: string, storageUpdateRequest: StorageUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Storage>>;
    /**
     * updateStorageAttributes
     * Updates an existing storage attributes by storage name. &lt;p&gt; This endpoint replaces the entire list of attributes on the Storage with the contents of the request. Observe this example: &lt;ol&gt; &lt;li&gt;Three attributes present on the Storage.&lt;/li&gt; &lt;li&gt;This endpoint is called with a single attribute in the request with an updated value.&lt;/li&gt; &lt;li&gt;After this operation the Storage will have only one attribute – which is probably not the desired outcome.&lt;/li&gt; &lt;li&gt;Instead, supply all existing attributes and provide updated values and additional attributes as needed. The only case when an existing attribute should be left out is to remove the attribute.&lt;/li&gt; &lt;/ol&gt; &lt;/p&gt;
     * @param storageName the name of the storage
     * @param storageAttributesUpdateRequest the information needed to update storage attributes
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageUpdateStorageAttributes(storageName: string, storageAttributesUpdateRequest: StorageAttributesUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<Storage>;
    storageUpdateStorageAttributes(storageName: string, storageAttributesUpdateRequest: StorageAttributesUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Storage>>;
    storageUpdateStorageAttributes(storageName: string, storageAttributesUpdateRequest: StorageAttributesUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Storage>>;
}
