/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { StoragePolicy } from '../model/storagePolicy';
import { StoragePolicyCreateRequest } from '../model/storagePolicyCreateRequest';
import { StoragePolicyKeys } from '../model/storagePolicyKeys';
import { StoragePolicySearchRequest } from '../model/storagePolicySearchRequest';
import { StoragePolicySearchResponse } from '../model/storagePolicySearchResponse';
import { StoragePolicyUpdateRequest } from '../model/storagePolicyUpdateRequest';
import { Configuration } from '../configuration';
export declare class StoragePolicyService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createStoragePolicy
     * Creates a new storage policy. &lt;p&gt;Requires WRITE permission on storage policy namespace and storage policy filter namespace&lt;/p&gt;
     * @param storagePolicyCreateRequest the information needed to create the storage policy
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storagePolicyCreateStoragePolicy(storagePolicyCreateRequest: StoragePolicyCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<StoragePolicy>;
    storagePolicyCreateStoragePolicy(storagePolicyCreateRequest: StoragePolicyCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StoragePolicy>>;
    storagePolicyCreateStoragePolicy(storagePolicyCreateRequest: StoragePolicyCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StoragePolicy>>;
    /**
     * deleteStoragePolicy
     * Deletes an existing storage policy by key. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param storagePolicyName the storage policy name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storagePolicyDeleteStoragePolicy(namespace: string, storagePolicyName: string, observe?: 'body', reportProgress?: boolean): Observable<StoragePolicy>;
    storagePolicyDeleteStoragePolicy(namespace: string, storagePolicyName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StoragePolicy>>;
    storagePolicyDeleteStoragePolicy(namespace: string, storagePolicyName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StoragePolicy>>;
    /**
     * getStoragePolicy
     * Gets an existing storage policy by key. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param storagePolicyName the storage policy name
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storagePolicyGetStoragePolicy(namespace: string, storagePolicyName: string, observe?: 'body', reportProgress?: boolean): Observable<StoragePolicy>;
    storagePolicyGetStoragePolicy(namespace: string, storagePolicyName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StoragePolicy>>;
    storagePolicyGetStoragePolicy(namespace: string, storagePolicyName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StoragePolicy>>;
    /**
     * getStoragePolicyKeys
     * Gets a list of keys for all storage policies defined in the system for the specified namespace. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storagePolicyGetStoragePolicyKeys(namespace: string, observe?: 'body', reportProgress?: boolean): Observable<StoragePolicyKeys>;
    storagePolicyGetStoragePolicyKeys(namespace: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StoragePolicyKeys>>;
    storagePolicyGetStoragePolicyKeys(namespace: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StoragePolicyKeys>>;
    /**
     * searchStoragePolicies
     * Retrieves all storage policies existing in the system per specified search filters and keys. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param storagePolicySearchRequest the storage policy search request
     * @param fields the field options for the storage policy search response. The valid field options are: storagePolicyRule, storagePolicyFilter, storagePolicyTransition, status
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storagePolicySearchStoragePolicies(storagePolicySearchRequest: StoragePolicySearchRequest, fields?: string, observe?: 'body', reportProgress?: boolean): Observable<StoragePolicySearchResponse>;
    storagePolicySearchStoragePolicies(storagePolicySearchRequest: StoragePolicySearchRequest, fields?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StoragePolicySearchResponse>>;
    storagePolicySearchStoragePolicies(storagePolicySearchRequest: StoragePolicySearchRequest, fields?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StoragePolicySearchResponse>>;
    /**
     * updateStoragePolicy
     * Updates an existing storage policy by key. &lt;p&gt;Requires WRITE permission on storage policy namespace and storage policy filter namespace&lt;/p&gt;
     * @param namespace the namespace
     * @param storagePolicyName the storage policy name
     * @param storagePolicyUpdateRequest the information needed to update the storage policy
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storagePolicyUpdateStoragePolicy(namespace: string, storagePolicyName: string, storagePolicyUpdateRequest: StoragePolicyUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<StoragePolicy>;
    storagePolicyUpdateStoragePolicy(namespace: string, storagePolicyName: string, storagePolicyUpdateRequest: StoragePolicyUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StoragePolicy>>;
    storagePolicyUpdateStoragePolicy(namespace: string, storagePolicyName: string, storagePolicyUpdateRequest: StoragePolicyUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StoragePolicy>>;
}
