/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { StorageUnitNotificationRegistration } from '../model/storageUnitNotificationRegistration';
import { StorageUnitNotificationRegistrationCreateRequest } from '../model/storageUnitNotificationRegistrationCreateRequest';
import { StorageUnitNotificationRegistrationKeys } from '../model/storageUnitNotificationRegistrationKeys';
import { StorageUnitNotificationRegistrationUpdateRequest } from '../model/storageUnitNotificationRegistrationUpdateRequest';
import { Configuration } from '../configuration';
export declare class StorageUnitNotificationRegistrationService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createStorageUnitNotificationRegistration
     * Creates a new storage unit notification registration. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt; &lt;p&gt;Requires READ permission on filter namespace&lt;/p&gt; &lt;p&gt;Requires EXECUTE permission on ALL job action namespaces&lt;/p&gt;
     * @param storageUnitNotificationRegistrationCreateRequest the information needed to create the storage unit notification registration
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageUnitNotificationRegistrationCreateStorageUnitNotificationRegistration(storageUnitNotificationRegistrationCreateRequest: StorageUnitNotificationRegistrationCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<StorageUnitNotificationRegistration>;
    storageUnitNotificationRegistrationCreateStorageUnitNotificationRegistration(storageUnitNotificationRegistrationCreateRequest: StorageUnitNotificationRegistrationCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StorageUnitNotificationRegistration>>;
    storageUnitNotificationRegistrationCreateStorageUnitNotificationRegistration(storageUnitNotificationRegistrationCreateRequest: StorageUnitNotificationRegistrationCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StorageUnitNotificationRegistration>>;
    /**
     * deleteStorageUnitNotification
     * Deletes an existing storage unit notification registration by key. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt;
     * @param namespace the namespace of the storage unit notification registration
     * @param notificationName the name of the storage unit notification registration
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageUnitNotificationRegistrationDeleteStorageUnitNotification(namespace: string, notificationName: string, observe?: 'body', reportProgress?: boolean): Observable<StorageUnitNotificationRegistration>;
    storageUnitNotificationRegistrationDeleteStorageUnitNotification(namespace: string, notificationName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StorageUnitNotificationRegistration>>;
    storageUnitNotificationRegistrationDeleteStorageUnitNotification(namespace: string, notificationName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StorageUnitNotificationRegistration>>;
    /**
     * getStorageUnitNotificationRegistration
     * Gets an existing storage unit notification registration by key. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param namespace the namespace of the storage unit notification registration
     * @param notificationName the name of the storage unit notification registration
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageUnitNotificationRegistrationGetStorageUnitNotificationRegistration(namespace: string, notificationName: string, observe?: 'body', reportProgress?: boolean): Observable<StorageUnitNotificationRegistration>;
    storageUnitNotificationRegistrationGetStorageUnitNotificationRegistration(namespace: string, notificationName: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StorageUnitNotificationRegistration>>;
    storageUnitNotificationRegistrationGetStorageUnitNotificationRegistration(namespace: string, notificationName: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StorageUnitNotificationRegistration>>;
    /**
     * getStorageUnitNotificationRegistrationsByNamespace
     * Gets a list of keys for all existing storage unit notification registrations for the specified storage unit notification registration namespace.
     * @param namespace the namespace of the storage unit notification registration
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageUnitNotificationRegistrationGetStorageUnitNotificationRegistrationsByNamespace(namespace: string, observe?: 'body', reportProgress?: boolean): Observable<StorageUnitNotificationRegistrationKeys>;
    storageUnitNotificationRegistrationGetStorageUnitNotificationRegistrationsByNamespace(namespace: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StorageUnitNotificationRegistrationKeys>>;
    storageUnitNotificationRegistrationGetStorageUnitNotificationRegistrationsByNamespace(namespace: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StorageUnitNotificationRegistrationKeys>>;
    /**
     * getStorageUnitNotificationRegistrationsByNotificationFilter
     * &lt;p&gt; Gets a list of keys for all existing storage unit notification registrations that match the specified storage unit notification filter parameters. &lt;/p&gt; &lt;p&gt; This endpoint requires both namespace and name of the business object definition. &lt;/p&gt; &lt;p&gt;Requires READ permission on business object definition namespace&lt;/p&gt;
     * @param businessObjectDefinitionNamespace the namespace of the business object definition
     * @param businessObjectDefinitionName the name of the business object definition
     * @param businessObjectFormatUsage the usage of the business object format
     * @param businessObjectFormatFileType the file type of the business object format
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageUnitNotificationRegistrationGetStorageUnitNotificationRegistrationsByNotificationFilter(businessObjectDefinitionNamespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage?: string, businessObjectFormatFileType?: string, observe?: 'body', reportProgress?: boolean): Observable<StorageUnitNotificationRegistrationKeys>;
    storageUnitNotificationRegistrationGetStorageUnitNotificationRegistrationsByNotificationFilter(businessObjectDefinitionNamespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage?: string, businessObjectFormatFileType?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StorageUnitNotificationRegistrationKeys>>;
    storageUnitNotificationRegistrationGetStorageUnitNotificationRegistrationsByNotificationFilter(businessObjectDefinitionNamespace: string, businessObjectDefinitionName: string, businessObjectFormatUsage?: string, businessObjectFormatFileType?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StorageUnitNotificationRegistrationKeys>>;
    /**
     * updateStorageUnitNotificationRegistration
     * Updates an existing storage unit notification registration by key. &lt;p&gt;Requires WRITE permission on namespace&lt;/p&gt; &lt;p&gt;Requires READ permission on filter namespace&lt;/p&gt; &lt;p&gt;Requires EXECUTE permission on ALL job action namespaces&lt;/p&gt;
     * @param namespace the namespace of the storage unit notification registration
     * @param notificationName the name of the storage unit notification registration
     * @param storageUnitNotificationRegistrationUpdateRequest the information needed to update the storage unit notification registration
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    storageUnitNotificationRegistrationUpdateStorageUnitNotificationRegistration(namespace: string, notificationName: string, storageUnitNotificationRegistrationUpdateRequest: StorageUnitNotificationRegistrationUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<StorageUnitNotificationRegistration>;
    storageUnitNotificationRegistrationUpdateStorageUnitNotificationRegistration(namespace: string, notificationName: string, storageUnitNotificationRegistrationUpdateRequest: StorageUnitNotificationRegistrationUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<StorageUnitNotificationRegistration>>;
    storageUnitNotificationRegistrationUpdateStorageUnitNotificationRegistration(namespace: string, notificationName: string, storageUnitNotificationRegistrationUpdateRequest: StorageUnitNotificationRegistrationUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<StorageUnitNotificationRegistration>>;
}
