/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Tag } from '../model/tag';
import { TagCreateRequest } from '../model/tagCreateRequest';
import { TagListResponse } from '../model/tagListResponse';
import { TagSearchRequest } from '../model/tagSearchRequest';
import { TagSearchResponse } from '../model/tagSearchResponse';
import { TagUpdateRequest } from '../model/tagUpdateRequest';
import { Configuration } from '../configuration';
export declare class TagService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createTag
     * Creates a new tag.
     * @param tagCreateRequest the information needed to create the tag
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagCreateTag(tagCreateRequest: TagCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<Tag>;
    tagCreateTag(tagCreateRequest: TagCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Tag>>;
    tagCreateTag(tagCreateRequest: TagCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Tag>>;
    /**
     * deleteTag
     * Deletes an existing tag.
     * @param tagTypeCode the tag type code
     * @param tagCode the tag code
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagDeleteTag(tagTypeCode: string, tagCode: string, observe?: 'body', reportProgress?: boolean): Observable<Tag>;
    tagDeleteTag(tagTypeCode: string, tagCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Tag>>;
    tagDeleteTag(tagTypeCode: string, tagCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Tag>>;
    /**
     * getTag
     * Gets an existing tag.
     * @param tagTypeCode the tag type code
     * @param tagCode the tag code
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagGetTag(tagTypeCode: string, tagCode: string, observe?: 'body', reportProgress?: boolean): Observable<Tag>;
    tagGetTag(tagTypeCode: string, tagCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Tag>>;
    tagGetTag(tagTypeCode: string, tagCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Tag>>;
    /**
     * getTags
     * Retrieves all associated tags for the specified tag type code. When tagCode is null, return all tags of the tag type code, which has no parent (i.e. root tags). When tagCode is provided, return all tags of the tag type code and whose parent tag code is tagCode.
     * @param tagTypeCode the tag type&#39;s code.
     * @param tagCode the parent tag code.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagGetTags(tagTypeCode: string, tagCode?: string, observe?: 'body', reportProgress?: boolean): Observable<TagListResponse>;
    tagGetTags(tagTypeCode: string, tagCode?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TagListResponse>>;
    tagGetTags(tagTypeCode: string, tagCode?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TagListResponse>>;
    /**
     * searchTags
     * Retrieves all tags existing in the system per specified search filters and keys. For each tag entity, this endpoint returns tag key by default along with any other top-level elements as specified by the \&quot;fields\&quot; query string parameter. The list of tags returned by this endpoint is sorted alphabetically by tag&#39;s display name ascending.
     * @param tagSearchRequest the tag search request. The request can only accept a single search filter and a single search key
     * @param fields the field options for the tag type search response. The valid field options are: displayName, description, parentTagKey, hasChildren
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagSearchTags(tagSearchRequest: TagSearchRequest, fields?: string, observe?: 'body', reportProgress?: boolean): Observable<TagSearchResponse>;
    tagSearchTags(tagSearchRequest: TagSearchRequest, fields?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TagSearchResponse>>;
    tagSearchTags(tagSearchRequest: TagSearchRequest, fields?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TagSearchResponse>>;
    /**
     * updateTag
     * Updates an existing tag.
     * @param tagTypeCode the tag type code
     * @param tagCode the tag code
     * @param tagUpdateRequest the information needed to update the tag
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagUpdateTag(tagTypeCode: string, tagCode: string, tagUpdateRequest: TagUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<Tag>;
    tagUpdateTag(tagTypeCode: string, tagCode: string, tagUpdateRequest: TagUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Tag>>;
    tagUpdateTag(tagTypeCode: string, tagCode: string, tagUpdateRequest: TagUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Tag>>;
}
