/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { TagType } from '../model/tagType';
import { TagTypeCreateRequest } from '../model/tagTypeCreateRequest';
import { TagTypeKeys } from '../model/tagTypeKeys';
import { TagTypeSearchRequest } from '../model/tagTypeSearchRequest';
import { TagTypeSearchResponse } from '../model/tagTypeSearchResponse';
import { TagTypeUpdateRequest } from '../model/tagTypeUpdateRequest';
import { Configuration } from '../configuration';
export declare class TagTypeService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createTagType
     * Creates a new tag type.
     * @param tagTypeCreateRequest the information needed to create the tag type
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagTypeCreateTagType(tagTypeCreateRequest: TagTypeCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<TagType>;
    tagTypeCreateTagType(tagTypeCreateRequest: TagTypeCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TagType>>;
    tagTypeCreateTagType(tagTypeCreateRequest: TagTypeCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TagType>>;
    /**
     * deleteTagType
     * Deletes an existing tag type by tag type code.
     * @param tagTypeCode the tag type code
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagTypeDeleteTagType(tagTypeCode: string, observe?: 'body', reportProgress?: boolean): Observable<TagType>;
    tagTypeDeleteTagType(tagTypeCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TagType>>;
    tagTypeDeleteTagType(tagTypeCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TagType>>;
    /**
     * getTagType
     * Gets an existing tag type by tag type code.
     * @param tagTypeCode the tag type code
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagTypeGetTagType(tagTypeCode: string, observe?: 'body', reportProgress?: boolean): Observable<TagType>;
    tagTypeGetTagType(tagTypeCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TagType>>;
    tagTypeGetTagType(tagTypeCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TagType>>;
    /**
     * getTagTypes
     * Gets a list of tag type keys for all tag types defined in the system.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagTypeGetTagTypes(observe?: 'body', reportProgress?: boolean): Observable<TagTypeKeys>;
    tagTypeGetTagTypes(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TagTypeKeys>>;
    tagTypeGetTagTypes(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TagTypeKeys>>;
    /**
     * searchTagTypes
     * Retrieves all tag types existing in the system. For each tag type entity, the endpoint returns tag type key by default along with any other top-level elements as specified by the \&quot;fields\&quot; query string parameter. The list of tag types returned by the endpoint is sorted alphabetically by tag type&#39;s order value ascending.
     * @param tagTypeSearchRequest the tag type search request. The request does not take any search keys or filters
     * @param fields the field options for the tag type search response. The valid field options are: displayName, tagTypeOrder and description
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagTypeSearchTagTypes(tagTypeSearchRequest: TagTypeSearchRequest, fields?: string, observe?: 'body', reportProgress?: boolean): Observable<TagTypeSearchResponse>;
    tagTypeSearchTagTypes(tagTypeSearchRequest: TagTypeSearchRequest, fields?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TagTypeSearchResponse>>;
    tagTypeSearchTagTypes(tagTypeSearchRequest: TagTypeSearchRequest, fields?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TagTypeSearchResponse>>;
    /**
     * updateTagType
     * Updates an existing tag type.
     * @param tagTypeCode the tag type code
     * @param tagTypeUpdateRequest the information needed to update the tag type
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    tagTypeUpdateTagType(tagTypeCode: string, tagTypeUpdateRequest: TagTypeUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<TagType>;
    tagTypeUpdateTagType(tagTypeCode: string, tagTypeUpdateRequest: TagTypeUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TagType>>;
    tagTypeUpdateTagType(tagTypeCode: string, tagTypeUpdateRequest: TagTypeUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TagType>>;
}
