/**
 * herd
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.216.0-SNAPSHOT
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { UserNamespaceAuthorization } from '../model/userNamespaceAuthorization';
import { UserNamespaceAuthorizationCreateRequest } from '../model/userNamespaceAuthorizationCreateRequest';
import { UserNamespaceAuthorizationUpdateRequest } from '../model/userNamespaceAuthorizationUpdateRequest';
import { UserNamespaceAuthorizations } from '../model/userNamespaceAuthorizations';
import { Configuration } from '../configuration';
export declare class UserNamespaceAuthorizationService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * createUserNamespaceAuthorization
     * &lt;p&gt;Creates a new user namespace authorization.&lt;/p&gt; &lt;p&gt;The user ID field may be prefixed with a wildcard token character \&quot;*\&quot; to authorize multiple users access to the namespace. The wildcard only works for as a prefix to match the suffix of the user ID. If the wildcard appears anywhere other than the prefix, the user ID must match as-is. For example:&lt;/p&gt; &lt;ul&gt; &lt;li&gt;john.doe@domain.com - only authorizes user with ID \&quot;john.doe@domain.com\&quot;&lt;/li&gt; &lt;li&gt;*@domain.com - authorizes users that has the suffix \&quot;@domain.com\&quot;&lt;/li&gt; &lt;li&gt;* - authorizes all users&lt;/li&gt; &lt;li&gt;john.doe* - only authorizes user with ID \&quot;john.doe*\&quot;&lt;/li&gt; &lt;/ul&gt; &lt;p&gt;Requires GRANT permission on namespace&lt;/p&gt;
     * @param userNamespaceAuthorizationCreateRequest the information needed to create the user namespace authorization
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    userNamespaceAuthorizationCreateUserNamespaceAuthorization(userNamespaceAuthorizationCreateRequest: UserNamespaceAuthorizationCreateRequest, observe?: 'body', reportProgress?: boolean): Observable<UserNamespaceAuthorization>;
    userNamespaceAuthorizationCreateUserNamespaceAuthorization(userNamespaceAuthorizationCreateRequest: UserNamespaceAuthorizationCreateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UserNamespaceAuthorization>>;
    userNamespaceAuthorizationCreateUserNamespaceAuthorization(userNamespaceAuthorizationCreateRequest: UserNamespaceAuthorizationCreateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UserNamespaceAuthorization>>;
    /**
     * deleteUserNamespaceAuthorization
     * Deletes an existing user namespace authorization by key. &lt;p&gt;Requires GRANT permission on namespace&lt;/p&gt;
     * @param userId the user id
     * @param namespace the namespace
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    userNamespaceAuthorizationDeleteUserNamespaceAuthorization(userId: string, namespace: string, observe?: 'body', reportProgress?: boolean): Observable<UserNamespaceAuthorization>;
    userNamespaceAuthorizationDeleteUserNamespaceAuthorization(userId: string, namespace: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UserNamespaceAuthorization>>;
    userNamespaceAuthorizationDeleteUserNamespaceAuthorization(userId: string, namespace: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UserNamespaceAuthorization>>;
    /**
     * deleteUserNamespaceAuthorizationsByNamespace
     * Deletes all existing user namespace authorizations for the namespace.
     * @param namespace the namespace
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    userNamespaceAuthorizationDeleteUserNamespaceAuthorizationsByNamespace(namespace: string, observe?: 'body', reportProgress?: boolean): Observable<UserNamespaceAuthorizations>;
    userNamespaceAuthorizationDeleteUserNamespaceAuthorizationsByNamespace(namespace: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UserNamespaceAuthorizations>>;
    userNamespaceAuthorizationDeleteUserNamespaceAuthorizationsByNamespace(namespace: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UserNamespaceAuthorizations>>;
    /**
     * deleteUserNamespaceAuthorizationsByUserId
     * Deletes all existing user namespace authorizations for the specified user.
     * @param userId the user id
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    userNamespaceAuthorizationDeleteUserNamespaceAuthorizationsByUserId(userId: string, observe?: 'body', reportProgress?: boolean): Observable<UserNamespaceAuthorizations>;
    userNamespaceAuthorizationDeleteUserNamespaceAuthorizationsByUserId(userId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UserNamespaceAuthorizations>>;
    userNamespaceAuthorizationDeleteUserNamespaceAuthorizationsByUserId(userId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UserNamespaceAuthorizations>>;
    /**
     * getUserNamespaceAuthorization
     * Gets an existing user namespace authorization by key. &lt;p&gt;Requires READ permission on namespace&lt;/p&gt;
     * @param userId the user id
     * @param namespace the namespace
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    userNamespaceAuthorizationGetUserNamespaceAuthorization(userId: string, namespace: string, observe?: 'body', reportProgress?: boolean): Observable<UserNamespaceAuthorization>;
    userNamespaceAuthorizationGetUserNamespaceAuthorization(userId: string, namespace: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UserNamespaceAuthorization>>;
    userNamespaceAuthorizationGetUserNamespaceAuthorization(userId: string, namespace: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UserNamespaceAuthorization>>;
    /**
     * getUserNamespaceAuthorizationsByNamespace
     * Gets a list of user namespace authorizations for the specified namespace.
     * @param namespace the namespace
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    userNamespaceAuthorizationGetUserNamespaceAuthorizationsByNamespace(namespace: string, observe?: 'body', reportProgress?: boolean): Observable<UserNamespaceAuthorizations>;
    userNamespaceAuthorizationGetUserNamespaceAuthorizationsByNamespace(namespace: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UserNamespaceAuthorizations>>;
    userNamespaceAuthorizationGetUserNamespaceAuthorizationsByNamespace(namespace: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UserNamespaceAuthorizations>>;
    /**
     * getUserNamespaceAuthorizationsByUserId
     * Gets a list of user namespace authorizations for the specified user.
     * @param userId the user id
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    userNamespaceAuthorizationGetUserNamespaceAuthorizationsByUserId(userId: string, observe?: 'body', reportProgress?: boolean): Observable<UserNamespaceAuthorizations>;
    userNamespaceAuthorizationGetUserNamespaceAuthorizationsByUserId(userId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UserNamespaceAuthorizations>>;
    userNamespaceAuthorizationGetUserNamespaceAuthorizationsByUserId(userId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UserNamespaceAuthorizations>>;
    /**
     * updateUserNamespaceAuthorization
     * Updates an existing user namespace authorization by key. &lt;p&gt;Requires GRANT permission on namespace&lt;/p&gt;
     * @param userId the user id
     * @param namespace the namespace
     * @param userNamespaceAuthorizationUpdateRequest the information needed to update the user namespace authorization
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    userNamespaceAuthorizationUpdateUserNamespaceAuthorization(userId: string, namespace: string, userNamespaceAuthorizationUpdateRequest: UserNamespaceAuthorizationUpdateRequest, observe?: 'body', reportProgress?: boolean): Observable<UserNamespaceAuthorization>;
    userNamespaceAuthorizationUpdateUserNamespaceAuthorization(userId: string, namespace: string, userNamespaceAuthorizationUpdateRequest: UserNamespaceAuthorizationUpdateRequest, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UserNamespaceAuthorization>>;
    userNamespaceAuthorizationUpdateUserNamespaceAuthorization(userId: string, namespace: string, userNamespaceAuthorizationUpdateRequest: UserNamespaceAuthorizationUpdateRequest, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UserNamespaceAuthorization>>;
}
